﻿using NetTopologySuite.IO;
using NUnit.Framework;

namespace NetTopologySuite.Tests.Various
{
    public class GoogleIssueTrackerTests
    {
        [Test(Description = "WKBWriter added 4 extra bytes which caused picky SqlServer to reject polygons")]
        public void TestIssue147()
        {
            string wkt = "POLYGON ((-94.16 42.25, -94.15 42.26, -94.14 42.25, -94.16 42.25))";
            var geom = new WKTReader().Read(wkt);
            Assert.AreEqual(
                "0x010300000001000000040000000AD7A3703D8A57C000000000002045409A999999998957C0E17A14AE47214540295C8FC2F58857C000000000002045400AD7A3703D8A57C00000000000204540",
                "0x"+ WKBWriter.ToHex(geom.AsBinary()));
        }
    }
}
